/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  PartyAddressDto,
  PartyAddressDtoFromJSON,
  PartyAddressDtoFromJSONTyped,
  PartyAddressDtoToJSON,
} from './PartyAddressDto';

/**
 *
 * @export
 * @interface PartyDto
 */
export interface PartyDto {
  /**
   * Unique identifier for this party
   * @type {string}
   * @memberof PartyDto
   */
  id: string;
  /**
   * Name of party
   * @type {string}
   * @memberof PartyDto
   */
  name: string;
  /**
   * Swift BIC for this party
   * @type {string}
   * @memberof PartyDto
   */
  bic: string;
  /**
   * URL for this party's gateway
   * @type {string}
   * @memberof PartyDto
   */
  gatewayUrl: string;
  /**
   * Base64 encoded certificate
   * @type {string}
   * @memberof PartyDto
   */
  certificate: string;
  /**
   * Addresses for this party
   * @type {Array<PartyAddressDto>}
   * @memberof PartyDto
   */
  addresses: Array<PartyAddressDto>;
  /**
   * XinFin address
   * @type {string}
   * @memberof PartyDto
   */
  xinFinAddress?: string;
}

export function PartyDtoFromJSON(json: any): PartyDto {
  return PartyDtoFromJSONTyped(json, false);
}

export function PartyDtoFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): PartyDto {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    id: json['id'],
    name: json['name'],
    bic: json['bic'],
    gatewayUrl: json['gatewayUrl'],
    certificate: json['certificate'],
    addresses: (json['addresses'] as Array<any>).map(PartyAddressDtoFromJSON),
    xinFinAddress: !exists(json, 'xinFinAddress')
      ? undefined
      : json['xinFinAddress'],
  };
}

export function PartyDtoToJSON(value?: PartyDto | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    id: value.id,
    name: value.name,
    bic: value.bic,
    gatewayUrl: value.gatewayUrl,
    certificate: value.certificate,
    addresses: (value.addresses as Array<any>).map(PartyAddressDtoToJSON),
    xinFinAddress: value.xinFinAddress,
  };
}
